/**
 * <copyright>
 * </copyright>
 *
 * $Id: Association.java,v 1.5 2007/08/14 09:41:44 askehill Exp $
 */
package org.eclipse.stp.bpmn;

import org.eclipse.emf.ecore.EModelElement;

/**
 * <!-- begin-user-doc -->
 * A representation of the model object '<em><b>Association</b></em>'.
 * <!-- end-user-doc -->
 *
 * <p>
 * The following features are supported:
 * <ul>
 *   <li>{@link org.eclipse.stp.bpmn.Association#getDirection <em>Direction</em>}</li>
 *   <li>{@link org.eclipse.stp.bpmn.Association#getSource <em>Source</em>}</li>
 *   <li>{@link org.eclipse.stp.bpmn.Association#getTarget <em>Target</em>}</li>
 * </ul>
 * </p>
 *
 * @see org.eclipse.stp.bpmn.BpmnPackage#getAssociation()
 * @model extendedMetaData="name='Association' kind='elementOnly'"
 * @generated
 */
public interface Association extends EModelElement {
    /**
	 * Returns the value of the '<em><b>Direction</b></em>' attribute.
	 * The default value is <code>"None"</code>.
	 * The literals are from the enumeration {@link org.eclipse.stp.bpmn.DirectionType}.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Direction</em>' attribute isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Direction</em>' attribute.
	 * @see org.eclipse.stp.bpmn.DirectionType
	 * @see #isSetDirection()
	 * @see #unsetDirection()
	 * @see #setDirection(DirectionType)
	 * @see org.eclipse.stp.bpmn.BpmnPackage#getAssociation_Direction()
	 * @model default="None" unsettable="true"
	 *        extendedMetaData="kind='attribute' name='direction'"
	 * @generated
	 */
	DirectionType getDirection();

    /**
	 * Sets the value of the '{@link org.eclipse.stp.bpmn.Association#getDirection <em>Direction</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Direction</em>' attribute.
	 * @see org.eclipse.stp.bpmn.DirectionType
	 * @see #isSetDirection()
	 * @see #unsetDirection()
	 * @see #getDirection()
	 * @generated
	 */
	void setDirection(DirectionType value);

    /**
	 * Unsets the value of the '{@link org.eclipse.stp.bpmn.Association#getDirection <em>Direction</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #isSetDirection()
	 * @see #getDirection()
	 * @see #setDirection(DirectionType)
	 * @generated
	 */
	void unsetDirection();

    /**
	 * Returns whether the value of the '{@link org.eclipse.stp.bpmn.Association#getDirection <em>Direction</em>}' attribute is set.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return whether the value of the '<em>Direction</em>' attribute is set.
	 * @see #unsetDirection()
	 * @see #getDirection()
	 * @see #setDirection(DirectionType)
	 * @generated
	 */
	boolean isSetDirection();

    /**
	 * Returns the value of the '<em><b>Source</b></em>' container reference.
	 * It is bidirectional and its opposite is '{@link org.eclipse.stp.bpmn.Artifact#getAssociations <em>Associations</em>}'.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Source</em>' reference isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Source</em>' container reference.
	 * @see #setSource(Artifact)
	 * @see org.eclipse.stp.bpmn.BpmnPackage#getAssociation_Source()
	 * @see org.eclipse.stp.bpmn.Artifact#getAssociations
	 * @model opposite="associations" transient="false"
	 *        extendedMetaData="kind='attribute' name='source'"
	 * @generated
	 */
	Artifact getSource();

    /**
	 * Sets the value of the '{@link org.eclipse.stp.bpmn.Association#getSource <em>Source</em>}' container reference.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Source</em>' container reference.
	 * @see #getSource()
	 * @generated
	 */
    void setSource(Artifact value);

    /**
	 * Returns the value of the '<em><b>Target</b></em>' reference.
	 * It is bidirectional and its opposite is '{@link org.eclipse.stp.bpmn.IdentifiableNode#getAssociations <em>Associations</em>}'.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Target</em>' reference isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Target</em>' reference.
	 * @see #setTarget(IdentifiableNode)
	 * @see org.eclipse.stp.bpmn.BpmnPackage#getAssociation_Target()
	 * @see org.eclipse.stp.bpmn.IdentifiableNode#getAssociations
	 * @model opposite="associations"
	 *        extendedMetaData="kind='attribute' name='target'"
	 * @generated
	 */
	IdentifiableNode getTarget();

    /**
	 * Sets the value of the '{@link org.eclipse.stp.bpmn.Association#getTarget <em>Target</em>}' reference.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Target</em>' reference.
	 * @see #getTarget()
	 * @generated
	 */
    void setTarget(IdentifiableNode value);

} // Association